package com.bonus.material.repair.mapper;

import java.util.ArrayList;
import java.util.List;
import com.bonus.material.repair.domain.RepairApplyDetails;
import com.bonus.material.repair.domain.RepairAuditDetails;
import com.bonus.material.repair.domain.RepairTaskDetails;
import org.apache.ibatis.annotations.Param;

/**
 * 维修详细Mapper接口
 * 
 * @author xsheng
 * @date 2024-10-16
 */
public interface RepairApplyDetailsMapper {
    /**
     * 查询维修详细
     * 
     * @param id 维修详细主键
     * @return 维修详细
     */
    public RepairApplyDetails selectRepairApplyDetailsById(Long id);

    /**
     * 查询维修详细列表
     * 
     * @param repairApplyDetails 维修详细
     * @return 维修详细集合
     */
    public List<RepairApplyDetails> selectRepairApplyDetailsList(RepairApplyDetails repairApplyDetails);

    /**
     * 新增维修详细
     * 
     * @param repairApplyDetails 维修详细
     * @return 结果
     */
    public int insertRepairApplyDetails(RepairApplyDetails repairApplyDetails);

    /**
     * 修改维修详细
     * 
     * @param repairApplyDetails 维修详细
     * @return 结果
     */
    public int updateRepairApplyDetails(RepairApplyDetails repairApplyDetails);

    public int updateRepairApplyDetailsAfterReject(@Param("rejectRepairedNum") Long rejectRepairedNum, @Param("rejectScrapNum") Long rejectScrapNum, @Param("id") Long id);

    /**
     * 根据任务Id获取维修详细
     * @param taskId 任务信息ID
     */
    List<RepairTaskDetails> getRepairDetailsWhichNotSent(@Param("taskId") Long taskId);

    /**
     * 删除维修详细
     * 
     * @param id 维修详细主键
     * @return 结果
     */
    public int deleteRepairApplyDetailsById(Long id);

    public int deleteRepairApplyDetailsByTaskIdAndStatus(@Param("taskId") Long taskId, @Param("status") String status);

    /**
     * 批量删除维修详细
     * 
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteRepairApplyDetailsByIds(Long[] ids);

    /**
     * 批量根据维修ID数组查询维修任务单号
     */
    List<RepairAuditDetails> selectRepairCodeByIds(@Param("list") List<Long> list);

    /**
     * 根据维修ID查询维修任务单号
     * @param repairId
     * @return
     */
    RepairAuditDetails selectById(Long repairId);

    int updateStatus(@Param("repairId") Long repairId, @Param("status") Integer status);

    /**
     * 获取维修任务详情
     * @param ids
     * @return
     */
    List<RepairTaskDetails> getList(@Param("list") ArrayList<Long> ids);

    /**
     * 根据旧维修任务ID获取维修任务详情
     * @param oldWxTaskId
     * @return
     */
    List<RepairTaskDetails> getRepairDetails(Long oldWxTaskId);

    /**
     * 修改repair_apply_record维修任务详情状态
     * @param dto
     * @return
     */
    int updateRepairApplyDetailsAfterAudit(RepairAuditDetails dto);

    /**
     * 批量修改repair_apply_record维修任务详情状态
     */
    int updateRepairApplyDetailsAfterAuditBatch(@Param("list") List<RepairAuditDetails> list);

    /**
     * 根据back_id获取最大level
     * @param backId
     * @return
     */
    RepairTaskDetails getMaxLevel(Long backId);
}
